;********************************************************
; FICHIER........: Gradateur
; AUTEUR ........: S. Lichtenberger
; DESCRIPTION ...: 
;                
; NOTES .........:
; COPYRIGHT .....: S. Lichtenberger
; Version .......: 2/12/2005
;********************************************************

PROCESSOR	PIC12F675
INCLUDE	<P12F675.inc>
__config  _MCLRE_OFF & _CP_OFF  & _INTRC_OSC_NOCLKOUT & _WDT_OFF
;__config  _MCLRE_OFF & _CP_OFF  & _XT_OSC & _WDT_OFF

; Dfinition  GPIO et TRIS
           ; 

TrisBits        EQU  B'111110'

OptionBits	EQU	B'00000000' ; Pull up ON

#DEFINE Page0 Bcf STATUS,5
#DEFINE Page1 Bsf STATUS,5

#DEFINE Synchro GPIO,3
#DEFINE Triac GPIO,0


org 0x20
ValeurCourant RES 1
TimerH RES 1 ; caleur calcule du retard
TimerL RES 1 ;             "
CptDelai500us RES 1
CptDelai100ms RES 1
CptDivision Res 1


Org 0

; =========================================================================
; Dpart

Start:
goto start1
Org 4 ; vecteur IRQ

; IntRoutine : Mise en conduction du trias
IntRoutine:
bsf Triac
bcf T1CON,TMR1ON ; arrt timer
bcf PIR1,TMR1IF ; Mise  0 du flag indicateurs d'IRQ Timer1
retfie ; retour avec remise  1 de GIE


start1:

page1
call 3ffh
movwf OSCCAL
; Init Oscal pour 4 MHz
movlw OptionBits
movwf OPTION_REG
movlw Trisbits
movwf TRISIO
movlw b'01010100'
movwf ANSEL ; AN3 select en analogique
movlw b'1'
movwf PIE1
page0
movlw b'00001001'
movwf ADCON0 ; adresse H, vfref = VDD, Chanel 2, convertisseur ON
movlw b'00000000' ; Dvalidation timer 1
movwf T1CON
clrf	GPIO			; Prog Sorties  0
bsf INTCON,GIE
bsf INTCON,PEIE

; Fin des initialisations

Main:
; attente transition GP3 bas haut
; Synchro secteur  0

Bcl2:
btfss Synchro
goto Bcl2
bcf Triac
; Front montant dttect
; Set Timer : prpa dclenchement
; Met la valeur ncessaire dans le timer et lance le timer
movfw TimerH
movwf TMR1H
movfw TimerL
movwf TMR1L

bsf T1CON,TMR1ON ; Timer 1 ON

; Lecture courant
call LectureCourant
; attente front descendant

Bcl3:
btfsc Synchro
goto Bcl3
bcf Triac
movfw TimerH
movwf TMR1H
movfw TimerL
movwf TMR1L

bsf T1CON,TMR1ON ; Timer 1 ON
; attente T du 4-20mA

goto Bcl2


;================================================
LectureCourant:
bsf ADCON0,GO_DONE ; dpart conversion

BclAtADC:
btfsc ADCON0,GO_DONE ; Attente fin de conversion
goto BclAtADC

movfw ADRESH
movwf ValeurCourant; compris entre 0 et 255 ( 40  204 pour 4  20 mA)
movlw 40
subwf ValeurCourant,F
btfsc STATUS,C ; Retenue ?
goto Test164
clrf ValeurCourant
goto Transcoder

Test164:
movlw 163
subwf ValeurCourant,W
btfss STATUS,C ; Retenue ?
goto Transcoder
movlw 164
movwf ValeurCourant

Transcoder:
call TranscodeH
movwf TimerH
call TranscodeL
movwf TimerL

return ; Au retour, TimerH et TimerL contiennent la valeur
       ;  mettre dans le timer 1 pour avoir le dlai correct.


;==================================
Delai10us:
nop
nop
nop
nop
nop
nop
return

;==================================
Delai200us:
movlw 66
movwf CptDelai500us

Bcl200:
decfsz CptDelai500us,1
goto Bcl200
return

;==================================
Delai500us:
movlw 100
movwf CptDelai500us

Bcl500:
nop
nop
decfsz CptDelai500us,1
goto Bcl500
return

Delai5ms:
movlw 10
movwf CptDelai100ms

BclDelai5:
call Delai500us
decfsz CptDelai100ms,1
goto BclDelai5
return


;==================================
Delai100ms:
movlw 200
movwf CptDelai100ms

BclDelai100:
call Delai500us
decfsz CptDelai100ms,1
goto BclDelai100
return

;==================================
;Temps 0  10 ms selon la valeur du 4-20mA
T420:


return


; Transcodage courant -> retard

TranscodeH:
movlw HIGH TableTimerH
movwf PCLATH
movfw ValeurCourant		; Valeur du courant dans W
goto TableTimerH ; Transcodage, W contient la valeur transcode

; Transcodage courant -> retard

TranscodeL:
movlw HIGH TableTimerL
movwf PCLATH
movfw ValeurCourant		; Valeur du courant dans W
goto TableTimerL ; Transcodage, W contient la valeur transcode


DE "Gradateur 4-20mA - Version 2/12/05"


            ORG       H'200'   
;  INCLUDE   "Retards.inc"  ;
;  command translation table
;  Retards.inc 


TableTimerH:
addwf PCL,F
RETLW 0xD9
RETLW 0xDC
RETLW 0xDD
RETLW 0xDE
RETLW 0xDF
RETLW 0xDF
RETLW 0xE0
RETLW 0xE0
RETLW 0xE0
RETLW 0xE1
RETLW 0xE1
RETLW 0xE1
RETLW 0xE2
RETLW 0xE2
RETLW 0xE2
RETLW 0xE2
RETLW 0xE3
RETLW 0xE3
RETLW 0xE3
RETLW 0xE3
RETLW 0xE3
RETLW 0xE4
RETLW 0xE4
RETLW 0xE4
RETLW 0xE4
RETLW 0xE4
RETLW 0xE5
RETLW 0xE5
RETLW 0xE5
RETLW 0xE5
RETLW 0xE5
RETLW 0xE5
RETLW 0xE6
RETLW 0xE6
RETLW 0xE6
RETLW 0xE6
RETLW 0xE6
RETLW 0xE6
RETLW 0xE7
RETLW 0xE7
RETLW 0xE7
RETLW 0xE7
RETLW 0xE7
RETLW 0xE7
RETLW 0xE7
RETLW 0xE8
RETLW 0xE8
RETLW 0xE8
RETLW 0xE8
RETLW 0xE8
RETLW 0xE8
RETLW 0xE8
RETLW 0xE8
RETLW 0xE9
RETLW 0xE9
RETLW 0xE9
RETLW 0xE9
RETLW 0xE9
RETLW 0xE9
RETLW 0xE9
RETLW 0xE9
RETLW 0xEA
RETLW 0xEA
RETLW 0xEA
RETLW 0xEA
RETLW 0xEA
RETLW 0xEA
RETLW 0xEA
RETLW 0xEA
RETLW 0xEB
RETLW 0xEB
RETLW 0xEB
RETLW 0xEB
RETLW 0xEB
RETLW 0xEB
RETLW 0xEB
RETLW 0xEB
RETLW 0xEC
RETLW 0xEC
RETLW 0xEC
RETLW 0xEC
RETLW 0xEC
RETLW 0xEC
RETLW 0xEC
RETLW 0xEC
RETLW 0xED
RETLW 0xED
RETLW 0xED
RETLW 0xED
RETLW 0xED
RETLW 0xED
RETLW 0xED
RETLW 0xED
RETLW 0xED
RETLW 0xEE
RETLW 0xEE
RETLW 0xEE
RETLW 0xEE
RETLW 0xEE
RETLW 0xEE
RETLW 0xEE
RETLW 0xEE
RETLW 0xEF
RETLW 0xEF
RETLW 0xEF
RETLW 0xEF
RETLW 0xEF
RETLW 0xEF
RETLW 0xEF
RETLW 0xEF
RETLW 0xF0
RETLW 0xF0
RETLW 0xF0
RETLW 0xF0
RETLW 0xF0
RETLW 0xF0
RETLW 0xF0
RETLW 0xF1
RETLW 0xF1
RETLW 0xF1
RETLW 0xF1
RETLW 0xF1
RETLW 0xF1
RETLW 0xF1
RETLW 0xF2
RETLW 0xF2
RETLW 0xF2
RETLW 0xF2
RETLW 0xF2
RETLW 0xF2
RETLW 0xF2
RETLW 0xF3
RETLW 0xF3
RETLW 0xF3
RETLW 0xF3
RETLW 0xF3
RETLW 0xF3
RETLW 0xF4
RETLW 0xF4
RETLW 0xF4
RETLW 0xF4
RETLW 0xF4
RETLW 0xF5
RETLW 0xF5
RETLW 0xF5
RETLW 0xF5
RETLW 0xF5
RETLW 0xF6
RETLW 0xF6
RETLW 0xF6
RETLW 0xF6
RETLW 0xF7
RETLW 0xF7
RETLW 0xF7
RETLW 0xF7
RETLW 0xF8
RETLW 0xF8
RETLW 0xF9
RETLW 0xF9
RETLW 0xF9
RETLW 0xFA
RETLW 0xFB
RETLW 0xFC
RETLW 0xFD
RETLW 0xFE

;Nb de valeurs : 165

ORG       H'300'   

TableTimerL:
addwf PCL,F

RETLW 0x0F
RETLW 0xE5
RETLW 0xE9
RETLW 0xA3
RETLW 0x37
RETLW 0xB5
RETLW 0x25
RETLW 0x89
RETLW 0xE5
RETLW 0x39
RETLW 0x89
RETLW 0xD5
RETLW 0x1B
RETLW 0x5F
RETLW 0x9F
RETLW 0xDD
RETLW 0x19
RETLW 0x53
RETLW 0x8B
RETLW 0xC1
RETLW 0xF5
RETLW 0x29
RETLW 0x5B
RETLW 0x8B
RETLW 0xBB
RETLW 0xE9
RETLW 0x17
RETLW 0x45
RETLW 0x71
RETLW 0x9B
RETLW 0xC5
RETLW 0xEF
RETLW 0x19
RETLW 0x41
RETLW 0x69
RETLW 0x91
RETLW 0xB7
RETLW 0xDF
RETLW 0x05
RETLW 0x29
RETLW 0x4F
RETLW 0x73
RETLW 0x97
RETLW 0xBB
RETLW 0xDF
RETLW 0x03
RETLW 0x27
RETLW 0x49
RETLW 0x6B
RETLW 0x8D
RETLW 0xAF
RETLW 0xD1
RETLW 0xF3
RETLW 0x15
RETLW 0x35
RETLW 0x57
RETLW 0x77
RETLW 0x97
RETLW 0xB9
RETLW 0xD9
RETLW 0xF9
RETLW 0x19
RETLW 0x39
RETLW 0x59
RETLW 0x77
RETLW 0x97
RETLW 0xB7
RETLW 0xD7
RETLW 0xF5
RETLW 0x15
RETLW 0x33
RETLW 0x53
RETLW 0x71
RETLW 0x91
RETLW 0xAF
RETLW 0xCF
RETLW 0xED
RETLW 0x0B
RETLW 0x2B
RETLW 0x49
RETLW 0x67
RETLW 0x87
RETLW 0xA5
RETLW 0xC5
RETLW 0xE3
RETLW 0x01
RETLW 0x21
RETLW 0x3F
RETLW 0x5D
RETLW 0x7D
RETLW 0x9B
RETLW 0xBB
RETLW 0xD9
RETLW 0xF9
RETLW 0x17
RETLW 0x37
RETLW 0x55
RETLW 0x75
RETLW 0x95
RETLW 0xB5
RETLW 0xD3
RETLW 0xF3
RETLW 0x13
RETLW 0x33
RETLW 0x53
RETLW 0x73
RETLW 0x95
RETLW 0xB5
RETLW 0xD5
RETLW 0xF7
RETLW 0x17
RETLW 0x39
RETLW 0x5B
RETLW 0x7D
RETLW 0x9F
RETLW 0xC1
RETLW 0xE3
RETLW 0x05
RETLW 0x29
RETLW 0x4D
RETLW 0x71
RETLW 0x95
RETLW 0xB9
RETLW 0xDD
RETLW 0x03
RETLW 0x27
RETLW 0x4D
RETLW 0x75
RETLW 0x9B
RETLW 0xC3
RETLW 0xEB
RETLW 0x13
RETLW 0x3D
RETLW 0x67
RETLW 0x91
RETLW 0xBB
RETLW 0xE7
RETLW 0x15
RETLW 0x43
RETLW 0x71
RETLW 0xA1
RETLW 0xD1
RETLW 0x03
RETLW 0x37
RETLW 0x6B
RETLW 0xA1
RETLW 0xD9
RETLW 0x13
RETLW 0x4F
RETLW 0x8D
RETLW 0xCD
RETLW 0x11
RETLW 0x57
RETLW 0xA3
RETLW 0xF3
RETLW 0x47
RETLW 0xA3
RETLW 0x07
RETLW 0x77
RETLW 0xF5
RETLW 0x8B
RETLW 0x43
RETLW 0x47
RETLW 0xF0
RETLW 0xFF

;Nb de valeurs : 165


;================================================
;ORG 0x3ff
;db 0x34,0xA0 ; Valeur OSCAL - A lire pour chaque Proc avant son effacement.
END

